package com.example.data_push.service.impl;

import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.api.R;
import com.example.data_push.config.ZybConfig;
import com.example.data_push.dto.DataDto;
import com.example.data_push.service.PushDataService;
import com.example.data_push.util.JsonToXml2;
import com.example.data_push.vo.ZybVo;
import com.google.gson.Gson;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringEscapeUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.text.MessageFormat;

/**
 * @Author: wl
 * @Date: 2023/3/24
 * @Description:
 */
@Slf4j
@Service
public class PushDataServiceImpl implements PushDataService {


    @Autowired
    private ZybConfig zybConfig;



    @Override
    public R pushData(DataDto dto){
        if (StringUtils.isEmpty(dto.getDataJson())){
            return R.failed("无法获取到推送数据");
        }
        //转义处理
        String soapui = "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:ser=\"http://server.zhejian.com/\">" +
                "<soapenv:Header/>" +
                "<soapenv:Body>" +
                "<ser:all>" +
                "<!--Optional:-->" +
                "<arg0><![CDATA[" +
                "{0}" +
                "]]></arg0>" +
                "</ser:all>" +
                "</soapenv:Body>" +
                "</soapenv:Envelope>";
        String format = MessageFormat.format(soapui, dto.getDataJson());
        log.info("获取原始数据成功,原始数据为："+format);
        String result = HttpUtil.post(zybConfig.getUrl(), format);
        log.info("调用省直平台成功，转义前:" + result);
        result = StringEscapeUtils.unescapeXml(result);
        log.info("转义后:" + result);
        if (!result.contains("<data>")){
            return  R.failed("调用省直平台推送失败");
        }
        String substring = result.substring(result.indexOf("<data>"), result.indexOf("</data>") + 7);
        log.info("单位申报成功");
        return R.ok(substring);
    }





}
